#include "tileset.h"

tileset::tileset(){
  bitmap = 0;
  tileSizeX_ = 0;
  tileSizeY_ = 0;
  columns_ = 1;
  rows_ = 1;
  startX_ = 0;
  startY_ = 0;
}

tileset::tileset(int tileSizeX = 0, int tileSizeY = 0, 
                 int columns = 1, int rows = 1, int startX = 0, int startY = 0){
  bitmap = 0;
  tileSizeX_ = tileSizeX;
  tileSizeY_ = tileSizeY;
  columns_ = columns;
  rows_ = rows;
  startX_ = startX;
  startY_ = startY;
}

void tileset::blit(BITMAP *bmp, int x, int y, int frame, bool trans){
  int blitX = startX_ + (frame % columns_) * tileSizeX_;
  int blitY = startY_ + ((frame / columns_) % rows_) * tileSizeX_;
  if(trans){
    ::masked_blit(bitmap, bmp, blitX, blitY, x, y, tileSizeX_, tileSizeY_);
  }else{
    ::blit(bitmap, bmp, blitX, blitY, x, y, tileSizeX_, tileSizeY_);
  }
}



